Loading...
Searching...
No Matches
pcl::NarfKeypoint Class Reference
Module keypoints

NARF (Normal Aligned Radial Feature) keypoints. More...

`#include <pcl/keypoints/narf_keypoint.h>`

Inheritance diagram for pcl::NarfKeypoint:

## Classes

struct | Parameters
| Parameters used in this class. More...

## Public Types

using | Ptr = shared_ptr< NarfKeypoint >
using | ConstPtr = shared_ptr< const NarfKeypoint >
using | BaseClass = Keypoint< PointWithRange, int >
using | PointCloudOut = Keypoint< PointWithRange, int >::PointCloudOut
Public Types inherited from pcl::Keypoint< PointWithRange, int >
using | Ptr = shared_ptr< Keypoint< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Keypoint< PointInT, PointOutT > >
using | BaseClass = PCLBase< PointInT >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(pcl::index_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, pcl::index_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| NarfKeypoint (RangeImageBorderExtractor *range_image_border_extractor=nullptr, float support_size=-1.0f)
| ~NarfKeypoint () override
void | clearData ()
| Erase all data calculated for the current range image.
void | setRangeImageBorderExtractor (RangeImageBorderExtractor *range_image_border_extractor)
| Set the RangeImageBorderExtractor member (required)
RangeImageBorderExtractor * | getRangeImageBorderExtractor ()
| Get the RangeImageBorderExtractor member.
void | setRangeImage (const RangeImage *range_image)
| Set the RangeImage member of the RangeImageBorderExtractor.
float * | getInterestImage ()
| Extract interest value per image point.
const ::pcl::PointCloud< InterestPoint > & | getInterestPoints ()
| Extract maxima from an interest image.
const std::vector< bool > & | getIsInterestPointImage ()
| Set all points in the image that are interest points to true, the rest to false.
Parameters & | getParameters ()
| Getter for the parameter struct.
const RangeImage & | getRangeImage ()
| Getter for the range image of range_image_border_extractor_.
void | compute (PointCloudOut &output)
| Overwrite the compute function of the base class.
Public Member Functions inherited from pcl::Keypoint< PointWithRange, int >
| Keypoint ()=default
| Keypoint ()
| Empty constructor.
void | harrisCorner (PointWithRange &output, PointWithRange &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (PointWithRange &output, PointWithRange &input, const float sigma, bool SCALE)
void | hessianBlob (PointWithRange &output, PointWithRange &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (PointWithRange &output, PointWithRange &input1, PointWithRange &input2)
| ~Keypoint () override=default
| Empty destructor.
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for.
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used.
double | getSearchParameter ()
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection.
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors.
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
int | searchForNeighbors (pcl::index_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | calculateScaleSpace ()
void | calculateInterestImage ()
void | calculateCompleteInterestImage ()
void | calculateSparseInterestImage ()
void | calculateInterestPoints ()
void | detectKeypoints (PointCloudOut &output) override
| Detect key points.
Protected Member Functions inherited from pcl::Keypoint< PointWithRange, int >
virtual bool | initCompute ()
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

RangeImageBorderExtractor * | range_image_border_extractor_
Parameters | parameters_
float * | interest_image_ {nullptr}
::pcl::PointCloud< InterestPoint > * | interest_points_ {nullptr}
std::vector< bool > | is_interest_point_image_
std::vector< RangeImage * > | range_image_scale_space_
std::vector< RangeImageBorderExtractor * > | border_extractor_scale_space_
std::vector< float * > | interest_image_scale_space_
Protected Attributes inherited from pcl::Keypoint< PointWithRange, int >
std::string | name_
| The key point detection method's name.
SearchMethod | search_method_
| The search method template for indices.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

NARF (Normal Aligned Radial Feature) keypoints.

Input is a range image, output the indices of the keypoints See B. Steder, R. B. Rusu, K. Konolige, and W. Burgard Point Feature Extraction on 3D Range Scans Taking into Account Object Boundaries In Proc. of the IEEE Int. Conf. on Robotics &Automation (ICRA). 2011.

Author
  Bastian Steder

Definition at line 60 of file narf_keypoint.h.

## Member Typedef Documentation

## BaseClass

using pcl::NarfKeypoint::BaseClass = Keypoint<PointWithRange, int>

Definition at line 67 of file narf_keypoint.h.

## ConstPtr

using pcl::NarfKeypoint::ConstPtr = shared_ptr<const NarfKeypoint>

Definition at line 64 of file narf_keypoint.h.

## PointCloudOut

using pcl::NarfKeypoint::PointCloudOut = Keypoint<PointWithRange, int>::PointCloudOut

Definition at line 69 of file narf_keypoint.h.

## Ptr

using pcl::NarfKeypoint::Ptr = shared_ptr<NarfKeypoint>

Definition at line 63 of file narf_keypoint.h.

## Constructor & Destructor Documentation

## NarfKeypoint()

pcl::NarfKeypoint::NarfKeypoint | ( | RangeImageBorderExtractor * | range_image_border_extractor = `nullptr`,
|  | float | support_size = `-1.0f`
| ) |  |

## ~NarfKeypoint()

pcl::NarfKeypoint::~NarfKeypoint | ( |  | ) |

override

## Member Function Documentation

## calculateCompleteInterestImage()

void pcl::NarfKeypoint::calculateCompleteInterestImage | ( |  | ) |

protected

## calculateInterestImage()

void pcl::NarfKeypoint::calculateInterestImage | ( |  | ) |

protected

## calculateInterestPoints()

void pcl::NarfKeypoint::calculateInterestPoints | ( |  | ) |

protected

## calculateScaleSpace()

void pcl::NarfKeypoint::calculateScaleSpace | ( |  | ) |

protected

## calculateSparseInterestImage()

void pcl::NarfKeypoint::calculateSparseInterestImage | ( |  | ) |

protected

## clearData()

void pcl::NarfKeypoint::clearData | ( |  | ) |

Erase all data calculated for the current range image.

## compute()

void pcl::NarfKeypoint::compute | ( | PointCloudOut & | output | ) |

Overwrite the compute function of the base class.

## detectKeypoints()

void pcl::NarfKeypoint::detectKeypoints | ( | PointCloudOut & | output | ) |

override protected

Detect key points.

## getInterestImage()

float * pcl::NarfKeypoint::getInterestImage | ( |  | ) |

inline

Extract interest value per image point.

Definition at line 135 of file narf_keypoint.h.

## getInterestPoints()

const ::pcl::PointCloud< InterestPoint > & pcl::NarfKeypoint::getInterestPoints | ( |  | ) |

inline

Extract maxima from an interest image.

Definition at line 139 of file narf_keypoint.h.

## getIsInterestPointImage()

const std::vector< bool > & pcl::NarfKeypoint::getIsInterestPointImage | ( |  | ) |

inline

Set all points in the image that are interest points to true, the rest to false.

Definition at line 143 of file narf_keypoint.h.

## getParameters()

Parameters & pcl::NarfKeypoint::getParameters | ( |  | ) |

inline

Getter for the parameter struct.

Definition at line 147 of file narf_keypoint.h.

## getRangeImage()

const RangeImage & pcl::NarfKeypoint::getRangeImage | ( |  | ) |

Getter for the range image of range_image_border_extractor_.

## getRangeImageBorderExtractor()

RangeImageBorderExtractor * pcl::NarfKeypoint::getRangeImageBorderExtractor | ( |  | ) |

inline

Get the RangeImageBorderExtractor member.

Definition at line 127 of file narf_keypoint.h.

## setRangeImage()

void pcl::NarfKeypoint::setRangeImage | ( | const RangeImage * | range_image | ) |

Set the RangeImage member of the RangeImageBorderExtractor.

## setRangeImageBorderExtractor()

void pcl::NarfKeypoint::setRangeImageBorderExtractor | ( | RangeImageBorderExtractor * | range_image_border_extractor | ) |

Set the RangeImageBorderExtractor member (required)

## Member Data Documentation

## border_extractor_scale_space_

std::vector<RangeImageBorderExtractor*> pcl::NarfKeypoint::border_extractor_scale_space_

protected

Definition at line 183 of file narf_keypoint.h.

## interest_image_

float* pcl::NarfKeypoint::interest_image_ {nullptr}

protected

Definition at line 179 of file narf_keypoint.h.

## interest_image_scale_space_

std::vector<float*> pcl::NarfKeypoint::interest_image_scale_space_

protected

Definition at line 184 of file narf_keypoint.h.

## interest_points_

::pcl::PointCloud<InterestPoint>* pcl::NarfKeypoint::interest_points_ {nullptr}

protected

Definition at line 180 of file narf_keypoint.h.

## is_interest_point_image_

std::vector<bool> pcl::NarfKeypoint::is_interest_point_image_

protected

Definition at line 181 of file narf_keypoint.h.

## parameters_

Parameters pcl::NarfKeypoint::parameters_

protected

Definition at line 178 of file narf_keypoint.h.

## range_image_border_extractor_

RangeImageBorderExtractor* pcl::NarfKeypoint::range_image_border_extractor_

protected

Definition at line 177 of file narf_keypoint.h.

## range_image_scale_space_

std::vector<RangeImage*> pcl::NarfKeypoint::range_image_scale_space_

protected

Definition at line 182 of file narf_keypoint.h.

The documentation for this class was generated from the following file:

- pcl/keypoints/narf_keypoint.h